const fs = require('fs')
const { isdir, isfile, } = require('../common')
const { error } = require('../common')
const { extract, build, } = require('../api/mod')

function config(data,dir=process.env.PWD){
  const content = JSON.stringify(data,null,'\t')
  const pos = `${dir}/config`
  const structFile = `${pos}/struct.json`

  if(!isdir(pos)){
    fs.mkdirSync(pos)
  }
  if(!isfile(structFile)){
    fs.writeFileSync(structFile,content,{flag:'wx',mode:'0777'})
  }
}

function constants(str,constants){
  for(const cn in constants){
    if(constants[cn]){
     const rcn = `\\$${cn}\\$`
     const pkey = new RegExp(`${rcn}`,'g')
     let pstr = constants[cn]
     if(typeof constants[cn] === 'object'){
        pstr = JSON.stringify(constants[cn],null,'\t')
        pstr = pstr.replace(/"/g,'\'')
     }
     str = str.replace(pkey,pstr)
    }
  }
  return str
}

function output(proname,confPath){
  const bfCall = onBuildFile.__onBuildFileCall__
  let conf = null

  if(!proname){
    error('未定义项目名称')
    return
  }

  if(conf = extract()){
    build(proname,conf,bfCall? bfCall:null)
  }
}

function onBuildFile(cb){
   onBuildFile.__onBuildFileCall__ = cb
}

module.exports = {
  config,
  constants,
  output,
  onBuildFile,
}
